import { Options } from 'semantic-release'
import * as angularConfig from '@commitlint/config-angular'
import * as semanticReleaseConfig from '@codingame/semantic-release-config'

interface CommitAnalyzerReleaseRule {
  type: string
  release: string
}

const plugins = (semanticReleaseConfig as Options).plugins!

const commitAnalyzerPlugin: { releaseRules: CommitAnalyzerReleaseRule[] } = plugins
  .filter(c => Array.isArray(c) && c[0] === '@semantic-release/commit-analyzer')[0]![1]

const typeEnum = commitAnalyzerPlugin.releaseRules.map(rule => rule.type)

const config = {
  ...angularConfig,
  rules: {
    ...angularConfig.rules,
    'type-enum': [2, 'always', typeEnum]
  }
}

export = config
